--- a/Debian/Debhelper/Dh_Lib.pm	2016-07-09 09:53:02.000000000 +0000
+++ b/Debian/Debhelper/Dh_Lib.pm	2016-07-27 00:48:29.000000000 +0000
@@ -39,6 +39,8 @@
 	    &open_gz
 );
 
+use List::Util qw(any);
+
 # The Makefile changes this if debhelper is installed in a PREFIX.
 my $prefix="/usr";
 
@@ -968,6 +970,9 @@
 		}
 		if (/^(?:X[BC]*-)?Package-Type:\s*(.*)/i) {
 			$package_type=$1;
+			if ($package_type eq 'udeb' and any { $_ eq 'noudeb' } @profiles) {
+				$included_in_build_profile=0;
+			}
 		}
 		if (/^Multi-Arch: \s*(.*)\s*/i) {
 			$multiarch = $1;
@@ -977,15 +982,17 @@
 		# high enough version of dpkg-dev is needed anyways
 		if (/^Build-Profiles:\s*(.*)/i) {
 		        my $build_profiles=$1;
-			eval {
-				require Dpkg::BuildProfiles;
-				my @restrictions=Dpkg::BuildProfiles::parse_build_profiles($build_profiles);
-				if (@restrictions) {
-					$included_in_build_profile=Dpkg::BuildProfiles::evaluate_restriction_formula(\@restrictions, \@profiles);
+			if ($included_in_build_profile) {
+				eval {
+					require Dpkg::BuildProfiles;
+					my @restrictions=Dpkg::BuildProfiles::parse_build_profiles($build_profiles);
+					if (@restrictions) {
+						$included_in_build_profile=Dpkg::BuildProfiles::evaluate_restriction_formula(\@restrictions, \@profiles);
+					}
+				};
+				if ($@) {
+					error("The control file has a Build-Profiles field. Requires libdpkg-perl >= 1.17.14");
 				}
-			};
-			if ($@) {
-				error("The control file has a Build-Profiles field. Requires libdpkg-perl >= 1.17.14");
 			}
 		}
 
